## puppetserver 7.9.5

=== docker/Makefile ===
NAMESPACE ?= puppet
git_describe = $(shell git describe)
vcs_ref := $(shell git rev-parse HEAD)
build_date := $(shell date -u +%FT%T)
hadolint_available := $(shell hadolint --help > /dev/null 2>&1; echo $$?)
hadolint_command := hadolint
hadolint_container := ghcr.io/hadolint/hadolint:latest

export BUNDLE_PATH = $(PWD)/.bundle/gems
export BUNDLE_BIN = $(PWD)/.bundle/bin
export GEMFILE = $(PWD)/Gemfile
export DOCKER_BUILDKIT ?= 1
PUPPERWARE_ANALYTICS_STREAM ?= dev

ifeq ($(IS_RELEASE),true)
	VERSION ?= $(shell echo $(git_describe) | sed 's/-.*//')
	PRODUCT ?= puppetserver
	# to work around failures that occur between when the repo is tagged and when the package
	# is actually shipped, see if this version exists in dujour
	PUBLISHED_VERSION ?= $(shell curl --silent 'https://updates.puppetlabs.com/?product=$(PRODUCT)&version=$(VERSION)' | jq '."version"' | tr -d '"')
	# For our containers built from packages, we want those to be built once then never changed
	# so check to see if that container already exists on dockerhub
	CONTAINER_EXISTS = $(shell DOCKER_CLI_EXPERIMENTAL=enabled docker manifest inspect $(NAMESPACE)/puppetserver:$(VERSION) > /dev/null 2>&1; echo $$?)
ifeq ($(CONTAINER_EXISTS),0)
	SKIP_BUILD ?= true
else ifneq ($(VERSION),$(PUBLISHED_VERSION))
	SKIP_BUILD ?= true
endif

	BUILD_TYPE ?= release
	LATEST_VERSION ?= latest
else
	BUILD_TYPE ?= edge
	VERSION ?= edge
	IS_LATEST := false
endif

prep:
	@git fetch --unshallow ||:
	@git fetch origin 'refs/tags/*:refs/tags/*'
ifeq ($(SKIP_BUILD),true)
	@echo "SKIP_BUILD is true, exiting with 1"
	@exit 1
endif

lint:
ifeq ($(hadolint_available),0)
	@$(hadolint_command) puppetserver/Dockerfile
else
	@docker pull $(hadolint_container)
	@docker run --rm -v $(PWD)/puppetserver/Dockerfile:/Dockerfile \
		-i $(hadolint_container) $(hadolint_command) Dockerfile
endif

build: prep
	docker buildx build \
		${DOCKER_BUILD_FLAGS} \
		--load \
		--pull \
		--build-arg build_type=$(BUILD_TYPE) \
		--build-arg vcs_ref=$(vcs_ref) \
		--build-arg build_date=$(build_date) \
		--build-arg version=$(VERSION) \
		--build-arg pupperware_analytics_stream=$(PUPPERWARE_ANALYTICS_STREAM) \
		--file puppetserver/Dockerfile \
		--tag $(NAMESPACE)/puppetserver:$(VERSION) $(PWD)/..
ifeq ($(IS_LATEST),true)
	@docker tag $(NAMESPACE)/puppetserver:$(VERSION) \
		$(NAMESPACE)/puppetserver:$(LATEST_VERSION)
endif

test: prep
	@bundle install --path $$BUNDLE_PATH --gemfile $$GEMFILE --with test
	@bundle update
	@PUPPET_TEST_DOCKER_IMAGE=$(NAMESPACE)/puppetserver:$(VERSION) \
		bundle exec --gemfile $$GEMFILE \
		rspec --options puppetserver/.rspec spec

push-image: prep
	@docker push puppet/puppetserver:$(VERSION)
ifeq ($(IS_LATEST),true)
	@docker push puppet/puppetserver:$(LATEST_VERSION)
endif

push-readme:
	@docker pull sheogorath/readme-to-dockerhub
	@docker run --rm \
		-v $(PWD)/puppetserver/README.md:/data/README.md \
		-e DOCKERHUB_USERNAME="$(DOCKERHUB_USERNAME)" \
		-e DOCKERHUB_PASSWORD="$(DOCKERHUB_PASSWORD)" \
		-e DOCKERHUB_REPO_PREFIX=puppet \
		-e DOCKERHUB_REPO_NAME=puppetserver \
		sheogorath/readme-to-dockerhub

publish: push-image push-readme

.PHONY: prep lint build test publish push-image push-readme

=== debian/changelog ===
puppetserver (7.9.5-2+deb12u1) bookworm; urgency=medium

  * ship cronjob to clean up reportdir automatically (Closes: #1078911,
    #1080489)

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 05 Sep 2024 21:30:33 -0400

puppetserver (7.9.5-2) unstable; urgency=medium

  * abort service start/reload if mainpid dies (Closes: #1032241)
  * add patch fixing CVE-2023-1894 (Closes: #1035541)

 -- Jérôme Charaoui <jerome@riseup.net>  Sun, 07 May 2023 11:09:17 -0400

puppetserver (7.9.5-1) unstable; urgency=medium

  * New upstream version 7.9.5
  * remove ahead-of-time compilation of clojure classes
  * d/rules: reenable dh_strip_nondeterminism
  * d/rules: add missing jars on classpath

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 09 Feb 2023 21:11:26 -0500

puppetserver (7.9.4-2) unstable; urgency=medium

  [ Louis-Philippe Véronneau ]
  * d/rules, d/manpages: add manpages.

  [ Jérôme Charaoui ]
  * fix start/stop/reload cli subcommands
  * d/control:
    + use headless jdk in build-deps
    + tighten clojure build-dep which provides 1.x
    - drop obsolete libcomplete build-dep
  * d/patches: drop dependency version overrides
  * d/patches: drop misleading dropsonde config section
  * d/rules: add aot clojure packages to binary deps
  * generate tighter binary deps from package list
  * add README.Debian and README.source

 -- Jérôme Charaoui <jerome@riseup.net>  Wed, 08 Feb 2023 14:07:38 -0500

puppetserver (7.9.4-1) unstable; urgency=medium

  [ Thomas Goirand ]
  * Do not Recommends: puppet-module-puppetlabs-zfs-core that isn't in Debian.

  [ Antoine Beaupré ]
  * only restart on abormal failure conditions

  [ Jérôme Charaoui ]
  * New upstream version 7.9.4
  * d/control:
    + tighten clojure binary Depends: (Closes: #1030039)
    + use default-jre-headless in binary Depends
  * d/patches: ssldir patch not needed anymore
  * d/tests:
    + add logs to autopkgtest artifacts
    + improve test descriptions
  * d/control: use default-jre-headless in binary Depends
  * d/patches: ssldir patch not needed anymore

 -- Jérôme Charaoui <jerome@riseup.net>  Mon, 30 Jan 2023 14:47:36 -0500

puppetserver (7.9.3-3) unstable; urgency=medium

  * d/control: build transitional packages (Closes: #1028333)
  * d/control: change section from java to admin
  * d/rules: do not enable service upon installation
  * sync systemd service unit status with internal state
  * fix puppetserver subcommands
  * add missing cli subcommands
  * add jruby lib path to java arguments
  * add appropriate lintian overrides
  * improve autopkgtests using ruby-serverspec

 -- Jérôme Charaoui <jerome@riseup.net>  Mon, 23 Jan 2023 12:50:03 -0500

puppetserver (7.9.3-2) unstable; urgency=medium

  * tighten binary Depends: on ruby gems (Closes: #1029299)
  * d/control:
    + tighten hocon and puppet dependencies
    + add ruby to binary Depends:
    + improve package Description
    + fix silent crashes caused by old i18n lib
    + recommend puppetlabs core modules
    - ring-mock only needed for testsuite
    - remove nocheck flag from some Build-Deps
  * d/rules: remove versioned symlink for test jar
  * fix puppetserver binary missing its subcommand scripts

 -- Jérôme Charaoui <jerome@riseup.net>  Sun, 22 Jan 2023 11:21:53 -0500

puppetserver (7.9.3-1) unstable; urgency=medium

  * New upstream version 7.9.3
  * d/copyright: add myself to copyright for debian/*
  * d/control:
    + rework all dependencies (Closes: #1028327)
    + add missing dependency puppet-resource_api
    + add myself to Uploaders
    - remove unused package puppetserver-test
  * d/patches:
    + rebase for new upstream version
    + patch out optional test dependency
    + add upstream java17 compat patch for test
    + add jruby stdlib load_path patch
    + adapt ssldir in puppet.conf test fixtures
    + add RUBYLIB fix for autosign script
    + add patch to fix unknown symbol in tests
    + add patch fixing java17 io warnings in tests
    + add patch to adapt jruby test for debian
    + add patch to disable analytics services
    + change puppetlabs paths to Debian paths
    + remove symlink-cadir from ca init
  * d/rules:
    + build with leiningen
    + install vendored gems from tarball component
    + run full testsuite at build-time (Closes: #1028332)
    - drop maven_repo_helper
  * d/tests: add basic autopkgtest
  * bundle concurrent-ruby 1.1.5 due to version requirement
  * ship config files, binary (Closes: #1028334)
  * ship systemd service unit
  * ship README in docs

 -- Jérôme Charaoui <jerome@riseup.net>  Wed, 18 Jan 2023 18:03:57 -0500

puppetserver (6.18.0-2) experimental; urgency=medium

  * d/patches/0001: override Java restriction.
  * d/control: add new B-D that were previously taken care of by
    jruby-utils-clojure.
  * d/control: temporary B-D on junit5. This commit should be reverted once
    #1028024 has been closed.
  * d/control: Standards-Version update to 4.6.2. No changes.
  * d/rules: remove the dh_strip_nondeterminism override, it's not needed
    anymore.
  * d/control: temporary version restriction on libjson-simple-java, as the
    version in experimental break puppetserver.

 -- Louis-Philippe Véronneau <pollo@debian.org>  Fri, 06 Jan 2023 15:36:48 -0500

puppetserver (6.18.0-1) unstable; urgency=medium

  * New upstream version.
  * d/gbp.conf: create.
  * d/patches: refresh 0001.
  * d/control: replace liburl-clojure by liblambdaisland-uri-clojure.
  * d/control: pin a new version of libssl-utils-clojure, as this version
    requires it to run.

 -- Louis-Philippe Véronneau <pollo@debian.org>  Sun, 13 Feb 2022 22:24:25 -0500

puppetserver (6.14.1-3) unstable; urgency=medium

  * d/control: remove redundant build-dependency.
  * d/copyright: update debian/* date.
  * d/copyright: fix Apache entry.
  * d/control: Standards-Version update to 4.6.0. No changes.

 -- Louis-Philippe Véronneau <pollo@debian.org>  Sun, 13 Feb 2022 13:14:50 -0500

puppetserver (6.14.1-2) unstable; urgency=medium



=== debian/control ===
Source: puppetserver
Section: admin
Priority: optional
Maintainer: Puppet Package Maintainers <pkg-puppet-devel@alioth-lists.debian.net>
Uploaders:
 Louis-Philippe Véronneau <pollo@debian.org>,
 Jérôme Charaoui <jerome@riseup.net>,
Build-Depends:
 debhelper-compat (= 13),
 default-jdk-headless,
 facter (>= 4.0.44),
 hiera (>= 3.3.2),
 javahelper,
 leiningen,
 libbeckon-clojure,
 libclj-time-clojure (>= 0.15.2),
 libclojure-java (>= 1.11.1-2),
 libcomidi-clojure,
 libcommons-exec-java,
 libcommons-io-java (>= 2.8.0),
 libcommons-lang-java,
 libdujour-version-check-clojure,
 libjruby-utils-clojure (>= 4.0.3-3),
 libjson-simple-java (<= 3.0),
 libkitchensink-clojure (>= 3.2.1),
 liblambdaisland-uri-clojure,
 libliberator-clojure,
 libprismatic-schema-clojure (>= 1.1.12),
 libpuppetlabs-http-client-clojure (>= 2.1.0),
 libpuppetlabs-i18n-clojure (>= 0.9.2-2),
 libpuppetlabs-ring-middleware-clojure (>= 1.3.1-3),
 libraynes-fs-clojure (>= 1.5.2),
 libring-basic-authentication-clojure,
 libring-mock-clojure <!nocheck>,
 libsemver-clojure,
 libshell-utils-clojure (>= 1.0.2-3),
 libslingshot-clojure,
 libssl-utils-clojure (>= 3.5.0-2),
 libtools-namespace-clojure,
 libtrapperkeeper-authorization-clojure (>= 1.0.0-3),
 libtrapperkeeper-clojure (>= 3.2.0-2),
 libtrapperkeeper-comidi-metrics-clojure,
 libtrapperkeeper-filesystem-watcher-clojure (>= 1.2.2-3),
 libtrapperkeeper-metrics-clojure (>= 1.5.0-3),
 libtrapperkeeper-scheduler-clojure (>= 1.1.3-7),
 libtrapperkeeper-status-clojure (>= 1.1.1-3),
 libtrapperkeeper-webserver-jetty9-clojure (>= 4.4.1-4),
 libyaml-snake-java (>= 1.33),
 maven-repo-helper,
 python3-docutils,
 puppet-agent (>= 7.22.0-2),
 rename,
 ruby-deep-merge,
 ruby-fast-gettext,
 ruby-gettext,
 ruby-hocon (>= 1.3.1-2),
 ruby-locale,
 ruby-puppet-resource-api (>= 1.8.14),
 ruby-puppetserver-ca-cli (>= 2.3.6),
 ruby-semantic-puppet,
 ruby-text (>= 1.3.1),
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/puppet-team/puppetserver.git
Vcs-Browser: https://salsa.debian.org/puppet-team/puppetserver
Homepage: https://github.com/puppetlabs/puppetserver
Rules-Requires-Root: no

Package: puppetserver
Architecture: all
Depends:
 default-jre-headless,
 facter (>= 4.0.44),
 hiera (>= 3.3.2),
 jruby,
 libcomidi-clojure (>= 0.3.2),
 libcommons-io-java (>= 2.8.0),
 libjruby-utils-clojure (>= 4.0.3),
 libkitchensink-clojure (>= 3.2.0),
 libprismatic-schema-clojure (>= 1.1.12),
 libpuppetlabs-http-client-clojure (>= 2.1.0),
 libpuppetlabs-i18n-clojure (>= 0.9.2),
 libpuppetlabs-ring-middleware-clojure (>= 1.3.1),
 libtrapperkeeper-authorization-clojure (>= 1.0.0-2),
 libtrapperkeeper-clojure (>= 3.1.0),
 libtrapperkeeper-metrics-clojure (>= 1.5.0),
 libtrapperkeeper-webserver-jetty9-clojure (>= 4.1.0-2),
 libraynes-fs-clojure (>= 1.5.2),
 libssl-utils-clojure (>= 3.5.0),
 libyaml-snake-java (>= 1.33),
 puppet-agent (>= 7.21.0-2),
 ruby,
 ruby-puppet-resource-api (>= 1.8.14),
 ${rubyDepends},
 ${java:Depends},
 ${misc:Depends},
Recommends:
 puppet-module-puppetlabs-augeas-core,
 puppet-module-puppetlabs-cron-core,
 puppet-module-puppetlabs-host-core,
 puppet-module-puppetlabs-mount-core,
 puppet-module-puppetlabs-selinux-core,
 puppet-module-puppetlabs-sshkeys-core,
Description: configuration management system, server
 Puppet is a configuration management system that allows you to define the
 state of your IT infrastructure, then automatically enforces the correct
 state.
 .
 This package contains the Ruby/Clojure server component which compiles
 configurations for a fleet of Puppet agent nodes. This implementation
 replaces the previous Ruby-only implementation known as Puppet Master.

Package: puppet-master
Section: oldlibs
Architecture: all
Depends: puppetserver
Description: configuration management system, transitional package
 Puppet is a configuration management system that allows you to define the
 state of your IT infrastructure, then automatically enforces the correct
 state.
 .
 This is a transitional package provided to handle the transition from
 puppet-master to the puppetserver package. It can be safely removed.

Package: puppet-master-passenger
Section: oldlibs
Architecture: all
Depends: puppetserver
Description: configuration management system, transitional package
 Puppet is a configuration management system that allows you to define the
 state of your IT infrastructure, then automatically enforces the correct
 state.
 .
 This is a transitional package provided to handle the transition from
 puppet-master-passenger to the puppetserver package. It can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/javahelper/java-vars.mk

export LEIN_HOME=$(CURDIR)/.lein
export LEIN_OFFLINE=true
NAME=puppetserver

DEBIAN_GEMS=deep_merge fast_gettext hocon gettext locale puppetserver-ca text semantic_puppet

# used to generate dependencies on the upstream versions of these packages
RUBY_PACKAGES=ruby-deep-merge ruby-fast-gettext ruby-gettext ruby-hocon ruby-locale ruby-puppetserver-ca-cli ruby-semantic-puppet ruby-text

CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/slingshot.jar:/usr/share/java/clj-yaml.jar:/usr/share/java/snakeyaml-1.x.jar:/usr/share/java/commons-lang.jar:/usr/share/java/commons-io.jar:/usr/share/java/clj-time.jar:/usr/share/java/clj-semver.jar:/usr/share/java/schema.jar:/usr/share/java/fs.jar:/usr/share/java/liberator.jar:/usr/share/java/commons-exec.jar:/usr/share/java/metrics-core.jar:/usr/share/java/jruby-utils.jar:/usr/share/java/clj-shell-utils.jar:/usr/share/java/trapperkeeper.jar:/usr/share/java/trapperkeeper-status.jar:/usr/share/java/trapperkeeper-scheduler.jar:/usr/share/java/trapperkeeper-webserver-jetty9.jar:/usr/share/java/trapperkeeper-authorization.jar:/usr/share/java/trapperkeeper-comidi-metrics.jar:/usr/share/java/trapperkeeper-metrics.jar:/usr/share/java/trapperkeeper-filesystem-watcher.jar:/usr/share/java/kitchensink.jar:/usr/share/java/ssl-utils.jar:/usr/share/java/ring-middleware.jar:/usr/share/java/dujour-version-check.jar:/usr/share/java/http-client.jar:/usr/share/java/comidi.jar:/usr/share/java/i18n.jar:/usr/share/java/semver.jar:/usr/share/java/libtrapperkeeper-comidi-metrics-clojure.jar

%:
	dh $@ --with javahelper

override_dh_auto_configure:
	cd debian && ln -sf /usr/share/maven-repo .

override_dh_auto_build:
	# main build
	lein i18n make
	lein jar

execute_after_dh_auto_build:
	# bundle gems shipped as component tarballs
	mkdir -p target/vendored-jruby-gems
	cp -a rubygem-*/gems target/vendored-jruby-gems
	cp -a rubygem-*/specifications target/vendored-jruby-gems
	# create symlink tree for vendored-jruby-gems
	mkdir -p target/vendored-jruby-gems/gems
	mkdir -p target/vendored-jruby-gems/specifications
	$(foreach gem_name,$(DEBIAN_GEMS), \
		set -e; \
		gem=$(shell ls -1 /usr/share/rubygems-integration/all/specifications | grep -Po "^$(gem_name)-[0-9\.]+(?=\.gemspec)"); \
		ln -s /usr/share/rubygems-integration/all/specifications/$${gem}.gemspec target/vendored-jruby-gems/specifications; \
		if [ -e  /usr/share/rubygems-integration/all/gems/$${gem} ]; then \
			ln -s /usr/share/rubygems-integration/all/gems/$${gem} target/vendored-jruby-gems/gems; \
		else \
			mkdir -p target/vendored-jruby-gems/gems/$${gem}/lib; \
			cp -as /usr/lib/ruby/vendor_ruby/$(gem_name)*.rb target/vendored-jruby-gems/gems/$${gem}/lib; \
			ln -s /usr/lib/ruby/vendor_ruby/$(gem_name) target/vendored-jruby-gems/gems/$${gem}/lib; \
		fi; \
	)
	# prepare main binary
	mkdir -p target/bin
	sed -e 's/%DEB_VERSION_UPSTREAM%/$(DEB_VERSION_UPSTREAM)/' < debian/bin/puppetserver.in > target/bin/puppetserver
	# prepare cli subcommands defaults script
	# inject the jar classpath into cli-defaults.sh
	mkdir -p target/cli
	sed -e "s#%CLASSPATH%#$(CLASSPATH)#" < debian/bin/cli-defaults.sh.in > target/cli/cli-defaults.sh
	# prepare cli subcommands
	mkdir -p target/cli/apps
	cp debian/bin/cli/* target/cli/apps
	cp resources/ext/cli/* target/cli/apps
	find target/cli -name \*.erb | xargs sed -i \
		-e 's/<%= EZBake::Config\[:uberjar_name\] %>/puppetserver.jar/' \
		-e '1s|^#!/opt/puppetlabs/puppet/bin/ruby|#!/usr/bin/ruby|' \
		-e '1s|^#!/usr/bin/env bash|#!/bin/bash|'
	rename --filename -e 's/\.erb$$//' target/cli/**/*
	chmod +x target/cli/**/*
	# dropsonde unsupported
	@rm -f target/cli/apps/dropsonde

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# make hiera, facter and puppet gems available to the testsuite
	# upstream uses git submodules here, but we can use Debian sources instead
	for component in hiera facter puppet resource_api; do \
		mkdir -p ruby/$${component}/lib; \
		if [ "$$component" = "puppet" ]; then package=puppet-agent ; \
		elif [ "$$component" = "resource_api" ]; then package=ruby-puppet-resource-api ; \
		else package=$$component; fi; \
		dpkg -L $$package | grep -Po "^/usr/lib/ruby/vendor_ruby/\K.*" | \
			while read file; do \
				if [ -d /usr/lib/ruby/vendor_ruby/$$file ]; then \
					mkdir -p ruby/$${component}/lib/$$file; \
				else \
					ln -sf /usr/lib/ruby/vendor_ruby/$$file ruby/$${component}/lib/$$file; \
				fi; \
			done; \
	done
	# testsuite looks for gems in this directory
	cd target && ln -sf vendored-jruby-gems jruby-gem-home
	# run unit and integration tests
	PUPPETSERVER_HEAP_SIZE=6G lein test
endif

execute_before_dh_install:
	# cleanup vendored jruby gems
	@rm -rf target/vendored-jruby-gems/cache/*
	@rm -rf target/vendored-jruby-gems/gems/*/ext
	@rm -rf target/vendored-jruby-gems/gems/*/test
	@rm -rf target/vendored-jruby-gems/gems/*/samples
	@rm -rf target/vendored-jruby-gems/gems/*/spec

execute_before_dh_link:
	# create unversioned jar symlinks
	dh_link usr/share/puppetserver/puppetserver-$(DEB_VERSION_UPSTREAM).jar usr/share/puppetserver/puppetserver.jar
	# create private vendor_ruby directory for puppetserver's jruby
	mkdir -p debian/puppetserver/usr/lib/puppetserver/ruby/vendor_ruby
	for component in hiera facter puppet; do \
		ln -s /usr/lib/ruby/vendor_ruby/$$component debian/puppetserver/usr/lib/puppetserver/ruby/vendor_ruby/$$component; \
		ln -s /usr/lib/ruby/vendor_ruby/$${component}*.rb debian/puppetserver/usr/lib/puppetserver/ruby/vendor_ruby; \
	done

override_dh_installsystemd:
	dh_installsystemd --no-enable

override_dh_fixperms:
	# cli scripts need to have execute permission
	dh_fixperms -Xusr/share/puppetserver/cli

override_jh_manifest:
	jh_manifest -c "$(subst :, ,$(CLASSPATH))" -m puppetlabs.trapperkeeper.main usr/share/puppetserver/puppetserver-$(DEB_VERSION_UPSTREAM).jar

override_dh_gencontrol:
	# needed to tighten the binary Depends:
	# due to the ruby gem symlinks, see bug #1029299
	for dep in $(RUBY_PACKAGES); do \
		ver=$$(dpkg-query -f '$${source:Upstream-Version}' -W $${dep}); \
		ruby_depends="$${ruby_depends}, $${dep} (<< $${ver}.), $${dep} (>= $${ver}~~)"; \
	done; \
	dh_gencontrol -- -VrubyDepends="$${ruby_depends}" -VclojureAotDepends="$${aot_depends}"

override_dh_installman:
	mkdir debian/tmp/man
	for manpage_path in debian/manpages/*.rst; do \
		manpage=$$(basename $$manpage_path); \
		rst2man --exit-status=2 --report=1 $${manpage_path} "debian/tmp/man/$${manpage%%.*}".1; \
	done
	dh_installman debian/tmp/man/*.1

override_dh_clean:
	rm -f debian/maven-repo
	rm -Rf target ruby
	dh_clean -Xacceptance

=== debian/tests/control ===
Tests: serverspec
Depends:
 curl,
 puppet-module-puppetlabs-host-core,
 puppetserver,
 ruby-serverspec,
Restrictions: isolation-container, needs-root

=== debian/watch ===
version=4
opts="mode=git" \
https://github.com/puppetlabs/puppetserver.git \
refs/tags/([\d\.]+)

## puppetserver 8.4.0

=== debian/changelog ===
puppetserver (8.4.0-7) unstable; urgency=medium

  * Rebuild for ruby-puppetserver-ca-cli update.

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 05 Sep 2024 09:09:34 -0400

puppetserver (8.4.0-6) unstable; urgency=medium

  * d/patches: add patch to regenerate ca test certs (Closes: #1078635)
  * Remove constraints unnecessary since bullseye (oldstable)
  * remove cron job to delete old reports

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 05 Sep 2024 09:09:17 -0400

puppetserver (8.4.0-5) unstable; urgency=medium

  * Add debian/puppetserver.cron.daily to clean-up reports (Closes: #1078911).

 -- Thomas Goirand <zigo@debian.org>  Tue, 27 Aug 2024 11:21:52 +0200

puppetserver (8.4.0-4) unstable; urgency=medium

  * Rebuild for ruby-gettext update (Closes: #1077156)
  * d/rules: fix ftbfs in reproducible builds

 -- Jérôme Charaoui <jerome@riseup.net>  Sat, 27 Jul 2024 10:42:16 -0400

puppetserver (8.4.0-3) unstable; urgency=medium

  * d/patches: fix typo in patch description
  * d/tests: limit autopkgtests to amd64 and arm64

 -- Jérôme Charaoui <jerome@riseup.net>  Sun, 17 Mar 2024 15:32:03 -0400

puppetserver (8.4.0-2) unstable; urgency=medium

  * d/rules: don't hardcode jruby gem names
  * d/tests: add 'puppetserver ca' spec

 -- Jérôme Charaoui <jerome@riseup.net>  Fri, 15 Mar 2024 20:50:21 -0400

puppetserver (8.4.0-1) unstable; urgency=medium

  [ Jérôme Charaoui ]
  * d/rules: cleanup unused clojureAotDepends substvar

  [ Louis-Philippe Véronneau ]
  * update puppetserver-ca manpage

 -- Jérôme Charaoui <jerome@riseup.net>  Fri, 01 Mar 2024 18:08:21 -0500

puppetserver (8.4.0-1~exp1) experimental; urgency=medium

  [ Jérôme Charaoui ]
  * New upstream version 8.4.0
  * un-bundle concurrent-ruby gem
  * d/control:
    - drop hiera 3 dependency
    - drop direct facter dependency
    - remove puppet-module-*-core Recommends
    + bump puppet-agent dependency to 8
    + update clojure library dependencies
    + add binary depends on procps (Closes: #1050389)
  * d/patches:
    - drop patch merged upstream
    + refresh patches for new upstream version
    + add patch to switch back to jetty9
    + resolve ftbfs with java 21
  * d/rules:
    - drop clj-yaml from classpath
    - drop hiera 3 gem from test environment
  * d/tests:
    + fix gem list test
    + add test for access log
    + add regression test for #1063568
  * workaround for non-C locales (Closes: #1063568)
  * remove unrecongnized lintian tag

  [ Thomas Goirand ]
  * Add myself as uploader.
  * Add puppet-module-puppetlabs-mailalias-core as Recommends
    (Closes: #1050337).

 -- Jérôme Charaoui <jerome@riseup.net>  Sun, 18 Feb 2024 09:56:24 -0500

=== debian/control ===
--- 
+++ 
@@ -5,31 +5,32 @@
 Uploaders:
  Louis-Philippe Véronneau <pollo@debian.org>,
  Jérôme Charaoui <jerome@riseup.net>,
+ Thomas Goirand <zigo@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  default-jdk-headless,
- facter (>= 4.0.44),
- hiera (>= 3.3.2),
+ gem2deb,
  javahelper,
  leiningen,
  libbeckon-clojure,
- libclj-time-clojure (>= 0.15.2),
+ libclj-time-clojure,
  libclojure-java (>= 1.11.1-2),
  libcomidi-clojure,
  libcommons-exec-java,
- libcommons-io-java (>= 2.8.0),
+ libcommons-io-java,
  libcommons-lang-java,
  libdujour-version-check-clojure,
- libjruby-utils-clojure (>= 4.0.3-3),
+ libjruby-utils-clojure (>= 5.0.1),
  libjson-simple-java (<= 3.0),
  libkitchensink-clojure (>= 3.2.1),
  liblambdaisland-uri-clojure,
  libliberator-clojure,
- libprismatic-schema-clojure (>= 1.1.12),
+ libprismatic-schema-clojure,
  libpuppetlabs-http-client-clojure (>= 2.1.0),
  libpuppetlabs-i18n-clojure (>= 0.9.2-2),
  libpuppetlabs-ring-middleware-clojure (>= 1.3.1-3),
- libraynes-fs-clojure (>= 1.5.2),
+ libraynes-fs-clojure,
+ librbac-client-clojure (>= 1.1.5-2),
  libring-basic-authentication-clojure,
  libring-mock-clojure <!nocheck>,
  libsemver-clojure,
@@ -48,8 +49,10 @@
  libyaml-snake-java (>= 1.33),
  maven-repo-helper,
  python3-docutils,
- puppet-agent (>= 7.22.0-2),
+ puppet-agent (>= 8~~),
+ puppet-agent (<< 9~~),
  rename,
+ ruby-concurrent (>= 1.2.2),
  ruby-deep-merge,
  ruby-fast-gettext,
  ruby-gettext,
@@ -69,37 +72,33 @@
 Architecture: all
 Depends:
  default-jre-headless,
- facter (>= 4.0.44),
- hiera (>= 3.3.2),
  jruby,
- libcomidi-clojure (>= 0.3.2),
- libcommons-io-java (>= 2.8.0),
- libjruby-utils-clojure (>= 4.0.3),
+ libcomidi-clojure,
+ libcommons-io-java,
+ libjruby-utils-clojure (>= 5.0.1),
  libkitchensink-clojure (>= 3.2.0),
- libprismatic-schema-clojure (>= 1.1.12),
+ libprismatic-schema-clojure,
  libpuppetlabs-http-client-clojure (>= 2.1.0),
  libpuppetlabs-i18n-clojure (>= 0.9.2),
  libpuppetlabs-ring-middleware-clojure (>= 1.3.1),
- libtrapperkeeper-authorization-clojure (>= 1.0.0-2),
- libtrapperkeeper-clojure (>= 3.1.0),
+ libtrapperkeeper-authorization-clojure,
+ libtrapperkeeper-clojure,
  libtrapperkeeper-metrics-clojure (>= 1.5.0),
- libtrapperkeeper-webserver-jetty9-clojure (>= 4.1.0-2),
- libraynes-fs-clojure (>= 1.5.2),
+ libtrapperkeeper-webserver-jetty9-clojure,
+ libraynes-fs-clojure,
+ librbac-client-clojure (>= 1.1.5),
  libssl-utils-clojure (>= 3.5.0),
  libyaml-snake-java (>= 1.33),
- puppet-agent (>= 7.21.0-2),
+ procps,
+ puppet-agent (>= 8~~),
+ puppet-agent (<< 9~~),
  ruby,
  ruby-puppet-resource-api (>= 1.8.14),
  ${rubyDepends},
  ${java:Depends},
  ${misc:Depends},
 Recommends:
- puppet-module-puppetlabs-augeas-core,
- puppet-module-puppetlabs-cron-core,
- puppet-module-puppetlabs-host-core,
- puppet-module-puppetlabs-mount-core,
- puppet-module-puppetlabs-selinux-core,
- puppet-module-puppetlabs-sshkeys-core,
+ puppet-module-puppetlabs-mailalias-core,
 Description: configuration management system, server
  Puppet is a configuration management system that allows you to define the
  state of your IT infrastructure, then automatically enforces the correct

=== debian/rules ===
--- 
+++ 
@@ -7,12 +7,10 @@
 export LEIN_OFFLINE=true
 NAME=puppetserver
 
-DEBIAN_GEMS=deep_merge fast_gettext hocon gettext locale puppetserver-ca text semantic_puppet
+# ruby gems to include in puppetserver's jruby environment
+JRUBY_GEMS=$(shell cd resources/ext/build-scripts && cat jruby-gem-list.txt mri-gem-list-no-dependencies.txt | cut -d' ' -f1)
 
-# used to generate dependencies on the upstream versions of these packages
-RUBY_PACKAGES=ruby-deep-merge ruby-fast-gettext ruby-gettext ruby-hocon ruby-locale ruby-puppetserver-ca-cli ruby-semantic-puppet ruby-text
-
-CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/slingshot.jar:/usr/share/java/clj-yaml.jar:/usr/share/java/snakeyaml-1.x.jar:/usr/share/java/commons-lang.jar:/usr/share/java/commons-io.jar:/usr/share/java/clj-time.jar:/usr/share/java/clj-semver.jar:/usr/share/java/schema.jar:/usr/share/java/fs.jar:/usr/share/java/liberator.jar:/usr/share/java/commons-exec.jar:/usr/share/java/metrics-core.jar:/usr/share/java/jruby-utils.jar:/usr/share/java/clj-shell-utils.jar:/usr/share/java/trapperkeeper.jar:/usr/share/java/trapperkeeper-status.jar:/usr/share/java/trapperkeeper-scheduler.jar:/usr/share/java/trapperkeeper-webserver-jetty9.jar:/usr/share/java/trapperkeeper-authorization.jar:/usr/share/java/trapperkeeper-comidi-metrics.jar:/usr/share/java/trapperkeeper-metrics.jar:/usr/share/java/trapperkeeper-filesystem-watcher.jar:/usr/share/java/kitchensink.jar:/usr/share/java/ssl-utils.jar:/usr/share/java/ring-middleware.jar:/usr/share/java/dujour-version-check.jar:/usr/share/java/http-client.jar:/usr/share/java/comidi.jar:/usr/share/java/i18n.jar:/usr/share/java/semver.jar:/usr/share/java/libtrapperkeeper-comidi-metrics-clojure.jar
+CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/slingshot.jar:/usr/share/java/snakeyaml-1.x.jar:/usr/share/java/commons-lang.jar:/usr/share/java/commons-io.jar:/usr/share/java/clj-time.jar:/usr/share/java/clj-semver.jar:/usr/share/java/schema.jar:/usr/share/java/fs.jar:/usr/share/java/liberator.jar:/usr/share/java/commons-exec.jar:/usr/share/java/metrics-core.jar:/usr/share/java/jruby-utils.jar:/usr/share/java/clj-shell-utils.jar:/usr/share/java/trapperkeeper.jar:/usr/share/java/trapperkeeper-status.jar:/usr/share/java/trapperkeeper-scheduler.jar:/usr/share/java/trapperkeeper-webserver-jetty9.jar:/usr/share/java/trapperkeeper-authorization.jar:/usr/share/java/trapperkeeper-comidi-metrics.jar:/usr/share/java/trapperkeeper-metrics.jar:/usr/share/java/trapperkeeper-filesystem-watcher.jar:/usr/share/java/kitchensink.jar:/usr/share/java/ssl-utils.jar:/usr/share/java/ring-middleware.jar:/usr/share/java/dujour-version-check.jar:/usr/share/java/http-client.jar:/usr/share/java/comidi.jar:/usr/share/java/i18n.jar:/usr/share/java/semver.jar:/usr/share/java/libtrapperkeeper-comidi-metrics-clojure.jar
 
 %:
 	dh $@ --with javahelper
@@ -26,14 +24,10 @@
 	lein jar
 
 execute_after_dh_auto_build:
-	# bundle gems shipped as component tarballs
-	mkdir -p target/vendored-jruby-gems
-	cp -a rubygem-*/gems target/vendored-jruby-gems
-	cp -a rubygem-*/specifications target/vendored-jruby-gems
 	# create symlink tree for vendored-jruby-gems
 	mkdir -p target/vendored-jruby-gems/gems
 	mkdir -p target/vendored-jruby-gems/specifications
-	$(foreach gem_name,$(DEBIAN_GEMS), \
+	$(foreach gem_name,$(JRUBY_GEMS), \
 		set -e; \
 		gem=$(shell ls -1 /usr/share/rubygems-integration/all/specifications | grep -Po "^$(gem_name)-[0-9\.]+(?=\.gemspec)"); \
 		ln -s /usr/share/rubygems-integration/all/specifications/$${gem}.gemspec target/vendored-jruby-gems/specifications; \
@@ -67,9 +61,9 @@
 
 override_dh_auto_test:
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
-	# make hiera, facter and puppet gems available to the testsuite
+	# make facter and puppet gems available to the testsuite
 	# upstream uses git submodules here, but we can use Debian sources instead
-	for component in hiera facter puppet resource_api; do \
+	for component in facter puppet resource_api; do \
 		mkdir -p ruby/$${component}/lib; \
 		if [ "$$component" = "puppet" ]; then package=puppet-agent ; \
 		elif [ "$$component" = "resource_api" ]; then package=ruby-puppet-resource-api ; \
@@ -85,6 +79,11 @@
 	done
 	# testsuite looks for gems in this directory
 	cd target && ln -sf vendored-jruby-gems jruby-gem-home
+	# regenerate tls certificates used in https tests
+	cd dev-resources/puppetlabs/puppetserver && ( \
+		cp -a ruby/http_client_test ruby/http_client_test.save; \
+		cp -a certificate_authority_test/master/conf/ca certificate_authority_test/master/conf/ca.save; )
+	ruby $(CURDIR)/dev-resources/regen_certs.rb
 	# run unit and integration tests
 	PUPPETSERVER_HEAP_SIZE=6G lein test
 endif
@@ -118,13 +117,15 @@
 	jh_manifest -c "$(subst :, ,$(CLASSPATH))" -m puppetlabs.trapperkeeper.main usr/share/puppetserver/puppetserver-$(DEB_VERSION_UPSTREAM).jar
 
 override_dh_gencontrol:
-	# needed to tighten the binary Depends:
+	# tighten the binary Depends:
 	# due to the ruby gem symlinks, see bug #1029299
-	for dep in $(RUBY_PACKAGES); do \
-		ver=$$(dpkg-query -f '$${source:Upstream-Version}' -W $${dep}); \
-		ruby_depends="$${ruby_depends}, $${dep} (<< $${ver}.), $${dep} (>= $${ver}~~)"; \
+	echo "$(JRUBY_GEMS)"
+	for gem in $(JRUBY_GEMS); do \
+		package=$$(ruby -e "require 'gem2deb/package_name_mapping'; @mapping = Gem2Deb::PackageNameMapping.new(false); puts @mapping['$${gem}']") \
+		ver=$$(dpkg-query -f '$${source:Upstream-Version}' -W $${package}); \
+		ruby_depends="$${ruby_depends}, $${package} (<< $${ver}.), $${package} (>= $${ver}~~)"; \
 	done; \
-	dh_gencontrol -- -VrubyDepends="$${ruby_depends}" -VclojureAotDepends="$${aot_depends}"
+	dh_gencontrol -- -VrubyDepends="$${ruby_depends}"
 
 override_dh_installman:
 	mkdir debian/tmp/man
@@ -137,4 +138,10 @@
 override_dh_clean:
 	rm -f debian/maven-repo
 	rm -Rf target ruby
+	# cleanup regenerated certificates
+	-cd dev-resources/puppetlabs/puppetserver && ( \
+		test -f ruby/http_client_test.save && \
+		mv ruby/http_client_test.save ruby/http_client_test; \
+		test -f certificate_authority_test/master/conf/ca.save && \
+		mv certificate_authority_test/master/conf/ca.save certificate_authority_test/master/conf/ca; )
 	dh_clean -Xacceptance

## puppetserver 8.7.0

=== debian/changelog ===
puppetserver (8.7.0-5) unstable; urgency=medium

  * d/patches: fix ftbfs with uncommon timezone

 -- Jérôme Charaoui <jerome@riseup.net>  Tue, 06 May 2025 12:36:52 -0400

puppetserver (8.7.0-4) unstable; urgency=medium

  * Rebuild for new version of ruby-concurrent (Closes: #1100569)
  * d/control: bump Standards-Version, no changes needed
  * d/tests: add missing net-tools dependency
  * d/tests: fix serverspec in certain environments
  * d/tests: add a test for the puppetserver ca cert

 -- Jérôme Charaoui <jerome@riseup.net>  Mon, 24 Mar 2025 18:20:09 -0400

puppetserver (8.7.0-3) unstable; urgency=medium

  * Rebuild for new version of ruby-concurrent (Closes: #1092567)
  * d/patches: improve regen_certs script (Closes: #1078635)
  * d/rules: improve post-build cleanup

 -- Jérôme Charaoui <jerome@riseup.net>  Mon, 03 Feb 2025 23:21:30 -0500

puppetserver (8.7.0-2) unstable; urgency=medium

  [ Anton Lundin ]
  * add a small delay in service unit's ExecStartPost (Closes: #1069162)

  [ Jérôme Charaoui ]
  * silence cron job if package removed
  * d/rules: fix snakeyaml jar filename in classpath

 -- Jérôme Charaoui <jerome@riseup.net>  Fri, 22 Nov 2024 18:26:26 -0500

puppetserver (8.7.0-1) unstable; urgency=medium

  [ Jérôme Charaoui ]
  * New upstream version 8.7.0
  * ship reportdir cleanup cron job
  * add manpage for new puppetserver prune subcommand
  * drop obsolete NEWS files and debian/gem-download.sh script
  * d/control:
    + add new binding packages to Suggests
    + bump libshell-utils-clojure dep
    + bump Standards-Version, no changes needed
  * d/manpages: update issue tracker url
  * d/patches: drop test cert regen patch merged upstream
  * d/patches: refresh for new upstream version
  * d/rules
    + adjust to new gem path used for tests
    + fix manpage generation for single-package
    + move gem symlinking logic to helper script
    - drop custom heap size for tests
    - drop obsolete cleanup step
  * d/watch: use recommended pattern for github tags

  [ Thomas Goirand ]
  * Remove transition packages puppet-master and puppet-master-passenger, make
    puppetserver Breaks+Replaces them to have them removed automatically.

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 21 Nov 2024 16:05:02 -0500

=== debian/control ===
--- 
+++ 
@@ -34,7 +34,7 @@
  libring-basic-authentication-clojure,
  libring-mock-clojure <!nocheck>,
  libsemver-clojure,
- libshell-utils-clojure (>= 1.0.2-3),
+ libshell-utils-clojure (>= 2.0.0),
  libslingshot-clojure,
  libssl-utils-clojure (>= 3.5.0-2),
  libtools-namespace-clojure,
@@ -48,9 +48,9 @@
  libtrapperkeeper-webserver-jetty9-clojure (>= 4.4.1-4),
  libyaml-snake-java (>= 1.33),
  maven-repo-helper,
+ puppet-agent (<< 9~~),
+ puppet-agent (>= 8~~),
  python3-docutils,
- puppet-agent (>= 8~~),
- puppet-agent (<< 9~~),
  rename,
  ruby-concurrent (>= 1.2.2),
  ruby-deep-merge,
@@ -62,7 +62,7 @@
  ruby-puppetserver-ca-cli (>= 2.3.6),
  ruby-semantic-puppet,
  ruby-text (>= 1.3.1),
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/puppet-team/puppetserver.git
 Vcs-Browser: https://salsa.debian.org/puppet-team/puppetserver
 Homepage: https://github.com/puppetlabs/puppetserver
@@ -81,24 +81,33 @@
  libpuppetlabs-http-client-clojure (>= 2.1.0),
  libpuppetlabs-i18n-clojure (>= 0.9.2),
  libpuppetlabs-ring-middleware-clojure (>= 1.3.1),
+ libraynes-fs-clojure,
+ librbac-client-clojure (>= 1.1.5),
+ libssl-utils-clojure (>= 3.5.0),
  libtrapperkeeper-authorization-clojure,
  libtrapperkeeper-clojure,
  libtrapperkeeper-metrics-clojure (>= 1.5.0),
  libtrapperkeeper-webserver-jetty9-clojure,
- libraynes-fs-clojure,
- librbac-client-clojure (>= 1.1.5),
- libssl-utils-clojure (>= 3.5.0),
  libyaml-snake-java (>= 1.33),
  procps,
+ puppet-agent (<< 9~~),
  puppet-agent (>= 8~~),
- puppet-agent (<< 9~~),
  ruby,
  ruby-puppet-resource-api (>= 1.8.14),
- ${rubyDepends},
  ${java:Depends},
  ${misc:Depends},
+ ${rubyDepends},
 Recommends:
  puppet-module-puppetlabs-mailalias-core,
+Suggests:
+ hiera-eyaml-puppetserver,
+ trocla-puppetserver,
+Breaks:
+ puppet-master,
+ puppet-master-passenger,
+Replaces:
+ puppet-master,
+ puppet-master-passenger,
 Description: configuration management system, server
  Puppet is a configuration management system that allows you to define the
  state of your IT infrastructure, then automatically enforces the correct
@@ -107,27 +116,3 @@
  This package contains the Ruby/Clojure server component which compiles
  configurations for a fleet of Puppet agent nodes. This implementation
  replaces the previous Ruby-only implementation known as Puppet Master.
-
-Package: puppet-master
-Section: oldlibs
-Architecture: all
-Depends: puppetserver
-Description: configuration management system, transitional package
- Puppet is a configuration management system that allows you to define the
- state of your IT infrastructure, then automatically enforces the correct
- state.
- .
- This is a transitional package provided to handle the transition from
- puppet-master to the puppetserver package. It can be safely removed.
-
-Package: puppet-master-passenger
-Section: oldlibs
-Architecture: all
-Depends: puppetserver
-Description: configuration management system, transitional package
- Puppet is a configuration management system that allows you to define the
- state of your IT infrastructure, then automatically enforces the correct
- state.
- .
- This is a transitional package provided to handle the transition from
- puppet-master-passenger to the puppetserver package. It can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/javahelper/java-vars.mk

export LEIN_HOME=$(CURDIR)/.lein
export LEIN_OFFLINE=true

# ruby gems to include in puppetserver's jruby environment
JRUBY_GEMS := $(shell cd resources/ext/build-scripts && cat jruby-gem-list.txt mri-gem-list-no-dependencies.txt | cut -d' ' -f1)

# fake home directory for the testsuite
FAKE_HOME := $(shell mktemp -d)

CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/slingshot.jar:/usr/share/java/snakeyaml.jar:/usr/share/java/commons-lang.jar:/usr/share/java/commons-io.jar:/usr/share/java/clj-time.jar:/usr/share/java/clj-semver.jar:/usr/share/java/schema.jar:/usr/share/java/fs.jar:/usr/share/java/liberator.jar:/usr/share/java/commons-exec.jar:/usr/share/java/metrics-core.jar:/usr/share/java/jruby-utils.jar:/usr/share/java/clj-shell-utils.jar:/usr/share/java/trapperkeeper.jar:/usr/share/java/trapperkeeper-status.jar:/usr/share/java/trapperkeeper-scheduler.jar:/usr/share/java/trapperkeeper-webserver-jetty9.jar:/usr/share/java/trapperkeeper-authorization.jar:/usr/share/java/trapperkeeper-comidi-metrics.jar:/usr/share/java/trapperkeeper-metrics.jar:/usr/share/java/trapperkeeper-filesystem-watcher.jar:/usr/share/java/kitchensink.jar:/usr/share/java/ssl-utils.jar:/usr/share/java/ring-middleware.jar:/usr/share/java/dujour-version-check.jar:/usr/share/java/http-client.jar:/usr/share/java/comidi.jar:/usr/share/java/i18n.jar:/usr/share/java/semver.jar:/usr/share/java/libtrapperkeeper-comidi-metrics-clojure.jar

%:
	dh $@ --with javahelper

override_dh_auto_configure:
	cd debian && ln -sf /usr/share/maven-repo .

override_dh_auto_build:
	# main build
	lein i18n make
	lein jar

execute_after_dh_auto_build:
	# create symlink tree for vendored-jruby-gems
	for gem in $(JRUBY_GEMS); do \
		PUPPETSERVER_GEM_HOME=target/vendored-jruby-gems ./debian/puppetserver_gem_helper.sh $$gem; \
	done
	# prepare main binary
	mkdir -p target/bin
	sed -e 's/%DEB_VERSION_UPSTREAM%/$(DEB_VERSION_UPSTREAM)/' < debian/bin/puppetserver.in > target/bin/puppetserver
	# prepare cli subcommands defaults script
	# inject the jar classpath into cli-defaults.sh
	mkdir -p target/cli
	sed -e "s#%CLASSPATH%#$(CLASSPATH)#" < debian/bin/cli-defaults.sh.in > target/cli/cli-defaults.sh
	# prepare cli subcommands
	mkdir -p target/cli/apps
	cp debian/bin/cli/* target/cli/apps
	cp resources/ext/cli/* target/cli/apps
	find target/cli -name \*.erb | xargs sed -i \
		-e 's/<%= EZBake::Config\[:uberjar_name\] %>/puppetserver.jar/' \
		-e '1s|^#!/opt/puppetlabs/puppet/bin/ruby|#!/usr/bin/ruby|' \
		-e '1s|^#!/usr/bin/env bash|#!/bin/bash|'
	rename --filename -e 's/\.erb$$//' target/cli/**/*
	chmod +x target/cli/**/*
	# dropsonde unsupported
	@rm -f target/cli/apps/dropsonde

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# make facter and puppet gems available to the testsuite
	# upstream uses git submodules here, but we can use Debian sources instead
	for component in facter puppet resource_api; do \
		mkdir -p ruby/$${component}/lib; \
		if [ "$$component" = "puppet" ]; then package=puppet-agent ; \
		elif [ "$$component" = "resource_api" ]; then package=ruby-puppet-resource-api ; \
		else package=$$component; fi; \
		dpkg -L $$package | grep -Po "^/usr/lib/ruby/vendor_ruby/\K.*" | \
			while read file; do \
				if [ -d /usr/lib/ruby/vendor_ruby/$$file ]; then \
					mkdir -p ruby/$${component}/lib/$$file; \
				else \
					ln -sf /usr/lib/ruby/vendor_ruby/$$file ruby/$${component}/lib/$$file; \
				fi; \
			done; \
	done
	# symlink vendored gems to the test suite's custom gem-home
	# (see test/unit/puppetlabs/services/jruby/jruby_puppet_testutils.clj)
	mkdir -p $(FAKE_HOME)/.puppetlabs/opt/server/data/puppetserver
	ln -s $(CURDIR)/target/vendored-jruby-gems $(FAKE_HOME)/.puppetlabs/opt/server/data/puppetserver/jruby-gems
	# regenerate tls certificates used in https tests
	cd dev-resources/puppetlabs && ( \
		for testdir in puppetserver/ruby/http_client_test puppetserver/certificate_authority_test/master/conf puppetserver/certificate_authority_test/update_crls services/ca/certificate_authority_core_test/update_crls services/certificate_authority/certificate_authority_int_test/ca_true_test/master/conf services/certificate_authority/certificate_authority_int_test/infracrl_test/master/conf; do \
			cp -a $$testdir $${testdir}.clean; \
		done )
	ruby $(CURDIR)/dev-resources/regen_certs.rb
	# run unit and integration tests
	_JAVA_OPTIONS=-Duser.home=$(FAKE_HOME) lein test
endif

execute_before_dh_link:
	# create unversioned jar symlinks
	dh_link usr/share/puppetserver/puppetserver-$(DEB_VERSION_UPSTREAM).jar usr/share/puppetserver/puppetserver.jar
	# create private vendor_ruby directory for puppetserver's jruby
	mkdir -p debian/puppetserver/usr/lib/puppetserver/ruby/vendor_ruby
	for component in hiera facter puppet; do \
		ln -s /usr/lib/ruby/vendor_ruby/$$component debian/puppetserver/usr/lib/puppetserver/ruby/vendor_ruby/$$component; \
		ln -s /usr/lib/ruby/vendor_ruby/$${component}*.rb debian/puppetserver/usr/lib/puppetserver/ruby/vendor_ruby; \
	done

override_dh_installsystemd:
	dh_installsystemd --no-enable

override_dh_fixperms:
	# cli scripts need to have execute permission
	dh_fixperms -Xusr/share/puppetserver/cli

override_jh_manifest:
	jh_manifest -c "$(subst :, ,$(CLASSPATH))" -m puppetlabs.trapperkeeper.main usr/share/puppetserver/puppetserver-$(DEB_VERSION_UPSTREAM).jar

override_dh_gencontrol:
	# tighten the binary Depends:
	# due to the ruby gem symlinks, see bug #1029299
	for gem in $(JRUBY_GEMS); do \
		package=$$(ruby -e "require 'gem2deb/package_name_mapping'; @mapping = Gem2Deb::PackageNameMapping.new(false); puts @mapping['$${gem}']") \
		ver=$$(dpkg-query -f '$${source:Upstream-Version}' -W $${package}); \
		ruby_depends="$${ruby_depends}, $${package} (<< $${ver}.), $${package} (>= $${ver}~~)"; \
	done; \
	dh_gencontrol -- -VrubyDepends="$${ruby_depends}"

override_dh_installman:
	cd debian/manpages; \
	for man in *.rst; do \
		rst2man --exit-status=2 --report=1 $${man} "$${man%%.*}".1; \
	done
	dh_installman debian/manpages/*.1

override_dh_clean:
	rm -f debian/maven-repo debian/manpages/*.1
	rm -Rf .lein .lein-failures target
	rm -rf resources/puppetlabs resources/locales.clj
	rm -rf ruby/facter/* ruby/puppet/* ruby/resource_api/*
	# cleanup regenerated certificates
	-cd dev-resources/puppetlabs && ( \
		for testdir in puppetserver/ruby/http_client_test puppetserver/certificate_authority_test/master/conf puppetserver/certificate_authority_test/update_crls services/ca/certificate_authority_core_test/update_crls services/certificate_authority/certificate_authority_int_test/ca_true_test/master/conf services/certificate_authority/certificate_authority_int_test/infracrl_test/master/conf; do \
			test -d $${testdir}.clean && ( rm -rf $$testdir; mv $${testdir}.clean $$testdir ); \
		done )
	dh_clean -Xacceptance

=== debian/tests/control ===
Tests: serverspec
Depends:
 curl,
 net-tools,
 puppet-module-puppetlabs-host-core,
 puppetserver,
 ruby-serverspec,
Restrictions: isolation-container, needs-root
Architecture: amd64 arm64

=== debian/watch ===
version=4
opts=\
filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
searchmode=plain \
https://api.github.com/repos/puppetlabs/puppetserver/git/matching-refs/tags/ \
https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
